#include <avr/io.h>

#include "spi.h"

void SPI_init(void)
{
    // set SPI direction: MOSI and SCK as output, MISO as input
    SPI_DDR |= (1 << SPI_MOSI) | (1 << SPI_SCK) | (1 << PB4);
    SPI_DDR &= ~(1 << SPI_MISO);

    SPSR0 |= (1 << SPI2X0);			          // f_osc / 2

    // initialize SPI
    SPCR0 =  (1 << SPE0) |			          // enable
            (1 << MSTR0) |			          // master mode
            (0 << DORD0) |			          // MSB first
            (0 << CPOL0) | (0 << CPHA0) |	// mode 0
            (0 << SPR00);			          // f_osc / 2
}

#include <stdio.h>
uint8_t SPI_exchange(uint8_t data)
{
	SPDR0 = data;
	while(!(SPSR0 & (1 << SPIF0)));
	return SPDR0;
}

